# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado del resumen inicial del usuario o el proyecto. Este controlador es utilizado desde las secciones:
# * Sección inicio: visualizar los datos relativos al usuario
# * Sección proyectos: visualizar y los datos relativos al proyecto

class InfoController  < ApplicationController

  before_filter :obtiene_proyectos

  def index
    if @proyecto
      condiciones_tareas = ["estado_tarea.activo IS TRUE AND proyecto_id = ? AND (usuario_asignado_id IS NULL || usuario_asignado_id = ?)",@proyecto.id, @usuario_identificado.id]
      @tareas = Tarea.find( :all, :conditions => condiciones_tareas, :include => [:tipo_tarea, :estado_tarea], :order => ("fecha_inicio"))
    else
      condiciones_tareas = ["estado_tarea.activo IS TRUE AND ( (proyecto_id IN (?) && usuario_asignado_id IS NULL) || usuario_asignado_id = ? )",@usuario_identificado.proyecto, @usuario_identificado.id]
      @tareas = Tarea.find( :all, :conditions => condiciones_tareas, :include => [:tipo_tarea, :estado_tarea], :order => ("fecha_inicio"))
    end
    render 'proyecto' if @proyecto
    render 'agente' if @agente
    render 'usuario' unless @proyecto || @agente 
  end

  def mas_proyectos
    render :update do |page|
      page.replace params[:update], :partial => 'proyectos'
    end
  end

  private

    def obtiene_proyectos
      @proyectos = @usuario_identificado.proyecto.paginate(
	:conditions => ["definicion_estado.formulacion OR definicion_estado.aprobado"], :order => "definicion_estado.aprobado desc, proyecto.nombre", :include => "definicion_estado",
	:page => (params[:page] || 1), :per_page => 3) unless @proyecto || @agente
    end
end
