# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VGasto < ActiveRecord::Base
  #untranslate_all
  # valores =  proyecto_id (0), moneda_id (1), implementador_id (2), fecha_inicio (3), fecha_fin (4), tasa_cambio (5)

  scope :partida_de_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id,  partida_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

  scope :partida_de_implementador_sin_proyecto, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[0], valores[4]} as importe", 
                                 :group => "partida_id #{moneda valores[0]} #{agente valores[1], "implementador"} ",
                                 :conditions => condiciones_sin_proyecto(valores[0], valores[1], valores[2], valores[3], "implementador")  } }

  scope :partida_de_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :actividad_de_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

                                    
  scope :actividad_de_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :partida_proyecto_de_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

  # Cruza actividades y partidas para una moneda y un implementador
  scope :actividad_por_partida, lambda { |*valores| {
				:select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe",
				:group => "proyecto_id, partida_proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
				:conditions=> condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }
                                    
  scope :partida_proyecto_de_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :partida, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5]} as importe", 
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida => valores [7])  } }

  scope :partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5]} as importe", 
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida_proyecto => valores [7])  } }


  scope :subpartida_partida, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5] } as importe", 
                                 :conditions => condiciones( valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida => valores[7], :subpartida => (valores[8] || "isnull") ) } }

  scope :subpartida_partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5] } as importe", 
                                 :conditions => condiciones( valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida_proyecto => valores[7], :subpartida => (valores[8] || "isnull") ) } }


     
  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.moneda moneda_id
      return moneda_id == "todas" ? "" : ", moneda_id "
  end

  def self.agente agente_id, agente_rol
      return agente_id == "todos" ? "" : ", #{agente_rol}_id "
  end

  def self.condiciones proyecto_id, moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol, otros={}
     condiciones = {"proyecto_id" => proyecto_id, "fecha" => fecha_inicio..fecha_fin}
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     condiciones["partida_id"] = otros[:partida] if otros[:partida]
     condiciones["partida_proyecto_id"] = otros[:partida_proyecto] if otros[:partida_proyecto]
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida] == "isnull"
     return condiciones
  end

  def self.condiciones_sin_proyecto moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol
     condiciones = {"fecha" => fecha_inicio..fecha_fin}
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     return condiciones
  end

 # +++
 # Sobrecargamos la clase para incluir agrupaciones 
 # ---
 class << self

  # Para agrupaciones de datos, tenemos que construir la tabla columna a columna
  def partida_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.agente_id, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "0", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Otras aportaciones publicas externas
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "1", "importe" => p.importe , "fila_id" => p.fila_id }}
    # ONG/Agrupacion externa
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "2", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Otras aportaciones privadas externas
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "3", "importe" => p.importe , "fila_id" => p.fila_id }}
    # ONG Local
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "4", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Aportaciones publicas locales
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "5", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Aportaciones privadas locales
    datos += partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "6", "importe" => p.importe , "fila_id" => p.fila_id }}
    return datos
  end

  def partida_proyecto_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.agente_id, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "0", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Otras aportaciones publicas externas
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "1", "importe" => p.importe , "fila_id" => p.fila_id }}
    # ONG/Agrupacion externa
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "2", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Otras aportaciones privadas externas
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "3", "importe" => p.importe , "fila_id" => p.fila_id }}
    # ONG Local
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "4", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Aportaciones publicas locales
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "5", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Aportaciones privadas locales
    datos += partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "6", "importe" => p.importe , "fila_id" => p.fila_id }}
    return datos
  end

  def actividad_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.agente_id, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "0", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Otras aportaciones publicas externas
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "1", "importe" => p.importe , "fila_id" => p.fila_id }}
    # ONG/Agrupacion externa
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "2", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Otras aportaciones privadas externas
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "3", "importe" => p.importe , "fila_id" => p.fila_id }}
    # ONG Local
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "4", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Aportaciones publicas locales
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "5", "importe" => p.importe , "fila_id" => p.fila_id }}
    # Aportaciones privadas locales
    datos += actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio).collect {|p| {"columna_id" => "6", "importe" => p.importe , "fila_id" => p.fila_id }}
    return datos
  end

 end

end
