# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VPresupuesto < ActiveRecord::Base
  #untranslate_all
  scope :partida_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

  scope :partida_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }


  scope :actividad_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "}  #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

                                    
  scope :actividad_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2]) } }

  scope :partida_proyecto_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

                                    
  scope :partida_proyecto_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2]) } }


  scope :actividad_financiador_agrupado, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{valores[5]} as columna_id, #{importe valores[2], valores[3]} as importe",
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], :financiador => valores[4]) } }

  scope :partida_financiador_agrupado, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{valores[5]} as columna_id, #{importe valores[2], valores[3]} as importe",
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], :financiador => valores[4]) } }

  scope :partida_proyecto_financiador_agrupado, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{valores[5]} as columna_id, #{importe valores[2], valores[3]} as importe",
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], :financiador => valores[4]) } }

     
  scope :financiador, lambda { |*valores| {
                                 :select => "#{importe 'todas', '1' } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => {"proyecto_id" => valores[0], "financiador_id" => valores[1] }  } }

  scope :subpartida_partida, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida => valores[4], :subpartida => (valores[5] || "isnull") ) } }

  scope :subpartida_partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida_proyecto => valores[4], :subpartida => (valores[5] || "isnull") ) } }

  scope :partida, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida => valores[4] ) } }

  scope :partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida_proyecto => valores[4] ) } }

  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.condiciones proyecto_id, etapa_id, moneda_id, otros={}
     condiciones = {"proyecto_id" => proyecto_id} 
     condiciones["etapa_id"] = etapa_id unless etapa_id == "todas"
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones["partida_id"] = otros[:partida] if otros[:partida]
     condiciones["partida_proyecto_id"] = otros[:partida_proyecto] if otros[:partida_proyecto]
     condiciones["financiador_id"] = otros[:financiador] if otros[:financiador]
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida] == "isnull"
     return condiciones
  end


 # +++
 # Sobrecargamos la clase para incluir agrupaciones 
 # ---
 class << self

  # Para agrupaciones de datos, tenemos que construir la tabla columna a columna
  def partida_financiador_x_grupos proyecto_id, etapa_id, moneda_id, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.agente_id, 0
    # Otras aportaciones publicas externas
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_publico, 1
    # ONG/Agrupacion externa
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_ong, 2
    # Otras aportaciones privadas externas
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_privado, 3
    # ONG Local
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_ong, 4
    # Aportaciones publicas locales
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_publico, 5
    # Aportaciones privadas locales
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_privado, 6
    return [columnas_financiador_agrupado(proyecto), datos]
  end

  def partida_proyecto_financiador_x_grupos proyecto_id, etapa_id, moneda_id, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.agente_id, 0
    # Otras aportaciones publicas externas
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_publico, 1
    # ONG/Agrupacion externa
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_ong, 2
    # Otras aportaciones privadas externas
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_privado, 3
    # ONG Local
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_ong, 4
    # Aportaciones publicas locales
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_publico, 5
    # Aportaciones privadas locales
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_privado, 6

    return [columnas_financiador_agrupado(proyecto), datos]
  end

  def actividad_financiador_x_grupos proyecto_id, etapa_id, moneda_id, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.agente_id, 0
    # Otras aportaciones publicas externas
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_publico, 1
    # ONG/Agrupacion externa
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_ong, 2
    # Otras aportaciones privadas externas
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_privado, 3
    # ONG Local
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_ong, 4
    # Aportaciones publicas locales
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_publico, 5
    # Aportaciones privadas locales
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_privado, 6

    return [columnas_financiador_agrupado(proyecto), datos]
  end

  def columnas_financiador_agrupado proyecto
    return [
		{"id" => 0, "nombre" => proyecto.agente.nombre},
		{"id" => 1, "nombre" => _("Otras Aportaciones Públicas Externas")},
		{"id" => 2, "nombre" => _("ONG/Agrupación")},
		{"id" => 3, "nombre" => _("Otras Aportaciones Privadas Externas")},
		{"id" => 4, "nombre" => _("ONG Local")},
		{"id" => 5, "nombre" => _("Aportaciones Públicas Locales")},
		{"id" => 6, "nombre" => _("Población Beneficiaria/Aportaciones Privadas")}
           ]
  end

 end

end
